import { Type } from '@angular/core';
import { ChoiceHandler } from './choice';
import * as i0 from "@angular/core";
/**
 * service for registering custom components
 */
export declare class JsonSchemaFormService {
    /**
     * layout editor mode
     */
    editMode: boolean;
    /**
     * built-in formats
     */
    formats: {
        email: RegExp;
        ipv4: RegExp;
        url: RegExp;
        uri: RegExp;
    };
    /**
     * registry of custom widgets. The keys are the values used in schema.widgetType, the values
     * are the Type<any> of the custom widget component implementing WidgetComponent
     */
    registry: {};
    /**
     * context data accessible from JSONata expressions
     */
    context: {};
    /**
     * registry of displayWith objects
     */
    displayWithRegistry: {
        [key: string]: ChoiceHandler;
    };
    /**
     * register custom component
     * @param key     the name of the component which is used in schema extension: widget=custom, widgetType=key
     * @param value   the implementation class
     */
    registerComponent(key: string, value: Type<any>): void;
    /**
     * register displayWith implementations
     * @param key     the name of the implementation which is used in schema extension: displayWith=key
     * @param value   the implementation class
     */
    registerDisplayWith(key: string, value: ChoiceHandler): void;
    /**
     * set a context key
     */
    setContext(key: string, value: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<JsonSchemaFormService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<JsonSchemaFormService>;
}
